import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:pmu/data/repositories/bbc_repository.dart';
import 'package:pmu/presentation/home_page/bloc/bloc.dart';
import 'package:pmu/presentation/home_page/home_page.dart';


void main() {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      theme: ThemeData(
        colorScheme: ColorScheme.fromSeed(seedColor: Colors.lightBlueAccent),
        useMaterial3: true,
      ),
      home: RepositoryProvider<BbcRepository>(// чтобы ниже по дереву(в блок провайдере) был доступ к нашему репозиторию
        lazy: true,
        create: (_) => BbcRepository(),
        child: BlocProvider<HomeBloc>(// обернули чтобы сделать блок доступным внутри нашей страницы
            lazy: false,
            create: (context) => HomeBloc(context.read<BbcRepository>()),
            child: const MyHomePage()),
      ),
    );
  }
}






